--
-- NOTE:
--
-- File paths need to be edited. Search for $$PATH$$ and
-- replace it with the path to the directory containing
-- the extracted data files.
--
--
-- PostgreSQL database dump
--

-- Dumped from database version 9.6.8
-- Dumped by pg_dump version 9.6.8

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET client_min_messages = warning;
SET row_security = off;

ALTER TABLE ONLY public.votes DROP CONSTRAINT "votes_transactionId_fkey";
ALTER TABLE ONLY public.trs DROP CONSTRAINT "trs_blockId_fkey";
ALTER TABLE ONLY public.signatures DROP CONSTRAINT "signatures_transactionId_fkey";
ALTER TABLE ONLY public.multisignatures DROP CONSTRAINT "multisignatures_transactionId_fkey";
ALTER TABLE ONLY public.mem_accounts2u_multisignatures DROP CONSTRAINT "mem_accounts2u_multisignatures_accountId_fkey";
ALTER TABLE ONLY public.mem_accounts2u_delegates DROP CONSTRAINT "mem_accounts2u_delegates_accountId_fkey";
ALTER TABLE ONLY public.mem_accounts2multisignatures DROP CONSTRAINT "mem_accounts2multisignatures_accountId_fkey";
ALTER TABLE ONLY public.mem_accounts2delegates DROP CONSTRAINT "mem_accounts2delegates_accountId_fkey";
ALTER TABLE ONLY public.delegates DROP CONSTRAINT "delegates_transactionId_fkey";
ALTER TABLE ONLY public.blocks DROP CONSTRAINT "blocks_previousBlock_fkey";
DROP TRIGGER trg_memaccounts_update ON public.mem_accounts;
DROP TRIGGER rounds_fees_insert ON public.blocks;
DROP TRIGGER rounds_fees_delete ON public.blocks;
DROP INDEX public.votes_trs_id;
DROP INDEX public.trs_upper_sender_id;
DROP INDEX public.trs_upper_recipient_id;
DROP INDEX public.trs_type;
DROP INDEX public.trs_timestamp;
DROP INDEX public.trs_sender_id;
DROP INDEX public."trs_senderPublicKey";
DROP INDEX public."trs_rowId";
DROP INDEX public.trs_recipient_id;
DROP INDEX public.trs_block_id;
DROP INDEX public.signatures_trs_id;
DROP INDEX public.rounds_fees_timestamp;
DROP INDEX public.rounds_fees_round;
DROP INDEX public.rounds_fees_public_key;
DROP INDEX public.rounds_fees_height;
DROP INDEX public.rounds_fees_fees;
DROP INDEX public.peers_height;
DROP INDEX public.peers_broadhash;
DROP INDEX public.multisignatures_trs_id;
DROP INDEX public.mem_round_round;
DROP INDEX public.mem_round_address;
DROP INDEX public.mem_accounts_balance;
DROP INDEX public."mem_accounts2u_multisignatures_accountId";
DROP INDEX public."mem_accounts2u_delegates_accountId";
DROP INDEX public."mem_accounts2multisignatures_accountId";
DROP INDEX public."mem_accounts2delegates_accountId";
DROP INDEX public.idx_trs_id;
DROP INDEX public.idx_accounts_address;
DROP INDEX public.delegates_trs_id;
DROP INDEX public."blocks_totalFee";
DROP INDEX public."blocks_totalAmount";
DROP INDEX public.blocks_timestamp;
DROP INDEX public."blocks_rowId";
DROP INDEX public.blocks_rounds;
DROP INDEX public.blocks_reward;
DROP INDEX public."blocks_previousBlock";
DROP INDEX public."blocks_numberOfTransactions";
DROP INDEX public.blocks_height;
DROP INDEX public.blocks_generator_public_key;
ALTER TABLE ONLY public.trs DROP CONSTRAINT trs_pkey;
ALTER TABLE ONLY public.signatures DROP CONSTRAINT signatures_pkey;
ALTER TABLE ONLY public.peers DROP CONSTRAINT peers_pkey;
ALTER TABLE ONLY public.migrations DROP CONSTRAINT migrations_pkey;
ALTER TABLE ONLY public.mem_accounts DROP CONSTRAINT mem_accounts_pkey;
ALTER TABLE ONLY public.info DROP CONSTRAINT info_pkey;
ALTER TABLE ONLY public.exceptions DROP CONSTRAINT exceptions_pkey;
ALTER TABLE ONLY public.delegates DROP CONSTRAINT delegates_unique;
ALTER TABLE ONLY public.blocks DROP CONSTRAINT blocks_pkey;
ALTER TABLE ONLY public.peers DROP CONSTRAINT address_unique;
ALTER TABLE public.trs ALTER COLUMN "rowId" DROP DEFAULT;
ALTER TABLE public.peers ALTER COLUMN id DROP DEFAULT;
ALTER TABLE public.blocks ALTER COLUMN "rowId" DROP DEFAULT;
DROP SEQUENCE public."trs_rowId_seq";
DROP TABLE public.rounds_fees;
DROP SEQUENCE public.peers_id_seq;
DROP TABLE public.peers;
DROP TABLE public.migrations;
DROP TABLE public.mem_votes_snapshot;
DROP TABLE public.mem_round_snapshot;
DROP TABLE public.mem_round;
DROP TABLE public.mem_accounts2u_multisignatures;
DROP TABLE public.mem_accounts2u_delegates;
DROP TABLE public.mem_accounts2multisignatures;
DROP TABLE public.mem_accounts2delegates;
DROP TABLE public.mem_accounts;
DROP TABLE public.info;
DROP VIEW public.full_blocks_list;
DROP TABLE public.votes;
DROP TABLE public.trs;
DROP TABLE public.signatures;
DROP TABLE public.multisignatures;
DROP TABLE public.forks_stat;
DROP TABLE public.exceptions;
DROP TABLE public.delegates;
DROP SEQUENCE public."blocks_rowId_seq";
DROP VIEW public.blocks_list;
DROP TABLE public.blocks;
DROP FUNCTION public.rounds_fees_init();
DROP FUNCTION public.round_fees_insert();
DROP FUNCTION public.round_fees_delete();
DROP FUNCTION public.revert_mem_account();
DROP FUNCTION public.proc_balance_check();
DROP FUNCTION public.getblockrewards();
DROP FUNCTION public.calcsupply_test(height_start integer, height_end integer, expected_reward bigint);
DROP FUNCTION public.calcsupply(block_height integer);
DROP FUNCTION public.calcblockreward(block_height integer);
DROP TYPE public.blockrewards;
DROP EXTENSION plpgsql;
DROP SCHEMA public;
--
-- Name: public; Type: SCHEMA; Schema: -; Owner: postgres
--

CREATE SCHEMA public;


ALTER SCHEMA public OWNER TO postgres;

--
-- Name: SCHEMA public; Type: COMMENT; Schema: -; Owner: postgres
--

COMMENT ON SCHEMA public IS 'standard public schema';


--
-- Name: plpgsql; Type: EXTENSION; Schema: -; Owner: 
--

CREATE EXTENSION IF NOT EXISTS plpgsql WITH SCHEMA pg_catalog;


--
-- Name: EXTENSION plpgsql; Type: COMMENT; Schema: -; Owner: 
--

COMMENT ON EXTENSION plpgsql IS 'PL/pgSQL procedural language';


--
-- Name: blockrewards; Type: TYPE; Schema: public; Owner: rise
--

CREATE TYPE public.blockrewards AS (
	supply bigint,
	start integer,
	distance bigint,
	milestones bigint[]
);


ALTER TYPE public.blockrewards OWNER TO rise;

--
-- Name: calcblockreward(integer); Type: FUNCTION; Schema: public; Owner: rise
--

CREATE FUNCTION public.calcblockreward(block_height integer) RETURNS bigint
    LANGUAGE plpgsql IMMUTABLE
    AS $$ DECLARE r blockRewards; mile int; BEGIN IF block_height IS NULL OR block_height <= 0 THEN RETURN NULL; END IF; SELECT * FROM getBlockRewards() INTO r; IF block_height < r.start THEN RETURN 0; END IF; mile := FLOOR((block_height-r.start)/r.distance)+1; IF mile > array_length(r.milestones, 1) THEN mile := array_length(r.milestones, 1); END IF; RETURN r.milestones[mile]; END $$;


ALTER FUNCTION public.calcblockreward(block_height integer) OWNER TO rise;

--
-- Name: calcsupply(integer); Type: FUNCTION; Schema: public; Owner: rise
--

CREATE FUNCTION public.calcsupply(block_height integer) RETURNS bigint
    LANGUAGE plpgsql IMMUTABLE
    AS $$ DECLARE r blockRewards; mile int; BEGIN IF block_height IS NULL OR block_height <= 0 THEN RETURN NULL; END IF; SELECT * FROM getBlockRewards() INTO r; IF block_height < r.start THEN RETURN r.supply; END IF; mile := FLOOR((block_height-r.start)/r.distance)+1; IF mile > array_length(r.milestones, 1) THEN mile := array_length(r.milestones, 1); END IF; FOR m IN 1..mile LOOP IF m = mile THEN r.supply := r.supply + (block_height-r.start+1-r.distance*(m-1))*r.milestones[m]; ELSE r.supply := r.supply + r.distance*r.milestones[m]; END IF; END LOOP; RETURN r.supply; END $$;


ALTER FUNCTION public.calcsupply(block_height integer) OWNER TO rise;

--
-- Name: calcsupply_test(integer, integer, bigint); Type: FUNCTION; Schema: public; Owner: rise
--

CREATE FUNCTION public.calcsupply_test(height_start integer, height_end integer, expected_reward bigint) RETURNS boolean
    LANGUAGE plpgsql IMMUTABLE
    AS $$ DECLARE supply bigint; prev_supply bigint; BEGIN SELECT calcSupply(height_start-1) INTO prev_supply; FOR height IN height_start..height_end LOOP SELECT calcSupply(height) INTO supply; IF (prev_supply+expected_reward) <> supply THEN RETURN false; END IF; prev_supply := supply; END LOOP; RETURN true; END $$;


ALTER FUNCTION public.calcsupply_test(height_start integer, height_end integer, expected_reward bigint) OWNER TO rise;

--
-- Name: getblockrewards(); Type: FUNCTION; Schema: public; Owner: rise
--

CREATE FUNCTION public.getblockrewards() RETURNS public.blockrewards
    LANGUAGE plpgsql IMMUTABLE
    AS $$ DECLARE res blockRewards; supply bigint = 10000000000000000; start int = 1451520; distance bigint = 3000000; milestones bigint[] = ARRAY[ 500000000, 400000000, 300000000, 200000000, 100000000 ]; BEGIN res.supply = supply; res.start = start; res.distance = distance; res.milestones = milestones; RETURN res; END $$;


ALTER FUNCTION public.getblockrewards() OWNER TO rise;

--
-- Name: proc_balance_check(); Type: FUNCTION; Schema: public; Owner: rise
--

CREATE FUNCTION public.proc_balance_check() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
  BEGIN
    IF NEW."balance" < 0 OR NEW."u_balance" < 0 THEN
      -- IF account is not genesisAc
      -- count then raise exception
      IF NOT EXISTS(SELECT * from info where "key" = 'genesisAccount' and "value" = NEW."address") THEN
        -- CHECK IF account is among an exception
        RAISE WARNING 'Account % Running through exceptions', NEW.address;
        IF EXISTS (SELECT * from exceptions where "type" = 'account' AND "key" = NEW."address" AND "remainingCount" > 0) THEN
          UPDATE exceptions SET "remainingCount" = "remainingCount" - 1 where "type" = 'account' AND "key" = NEW."address";
        ELSE
          RAISE EXCEPTION 'Address % cannot go < 0 on balance: % u_balance: %', NEW.address, NEW."balance", NEW."u_balance";
        END IF;
      END IF;
    END IF;
    RETURN NEW;
  END;
$$;


ALTER FUNCTION public.proc_balance_check() OWNER TO rise;

--
-- Name: revert_mem_account(); Type: FUNCTION; Schema: public; Owner: rise
--

CREATE FUNCTION public.revert_mem_account() RETURNS trigger
    LANGUAGE plpgsql
    AS $$ BEGIN IF NEW."address" <> OLD."address" THEN RAISE WARNING 'Reverting change of address from % to %', OLD."address", NEW."address"; NEW."address" = OLD."address"; END IF; IF NEW."u_username" <> OLD."u_username" AND OLD."u_username" IS NOT NULL THEN RAISE WARNING 'Reverting change of u_username from % to %', OLD."u_username", NEW."u_username"; NEW."u_username" = OLD."u_username"; END IF; IF NEW."username" <> OLD."username" AND OLD."username" IS NOT NULL THEN RAISE WARNING 'Reverting change of username from % to %', OLD."username", NEW."username"; NEW."username" = OLD."username"; END IF; IF NEW."virgin" <> OLD."virgin" AND OLD."virgin" = 0 THEN RAISE WARNING 'Reverting change of virgin from % to %', OLD."virgin", NEW."virgin"; NEW."virgin" = OLD."virgin"; END IF; IF NEW."publicKey" <> OLD."publicKey" AND OLD."virgin" = 0 AND OLD."publicKey" IS NOT NULL THEN RAISE WARNING 'Reverting change of publicKey from % to %', ENCODE(OLD."publicKey", 'hex'), ENCODE(NEW."publicKey", 'hex'); NEW."publicKey" = OLD."publicKey"; END IF; IF NEW."secondPublicKey" <> OLD."secondPublicKey" AND OLD."secondPublicKey" IS NOT NULL THEN RAISE WARNING 'Reverting change of secondPublicKey from % to %', ENCODE(OLD."secondPublicKey", 'hex'), ENCODE(NEW."secondPublicKey", 'hex'); NEW."secondPublicKey" = OLD."secondPublicKey"; END IF; RETURN NEW; END $$;


ALTER FUNCTION public.revert_mem_account() OWNER TO rise;

--
-- Name: round_fees_delete(); Type: FUNCTION; Schema: public; Owner: rise
--

CREATE FUNCTION public.round_fees_delete() RETURNS trigger
    LANGUAGE plpgsql
    AS $$ BEGIN DELETE FROM rounds_fees WHERE CEIL(height / 101::float)::int = (CEIL(OLD.height / 101::float)::int); RETURN NULL; END $$;


ALTER FUNCTION public.round_fees_delete() OWNER TO rise;

--
-- Name: round_fees_insert(); Type: FUNCTION; Schema: public; Owner: rise
--

CREATE FUNCTION public.round_fees_insert() RETURNS trigger
    LANGUAGE plpgsql
    AS $$ BEGIN WITH round AS (SELECT timestamp, height, "generatorPublicKey", "totalFee" FROM blocks WHERE CEIL(height / 101::float)::int = CEIL(NEW.height / 101::float)::int), fees AS (SELECT SUM("totalFee") AS total, FLOOR(SUM("totalFee") / 101) AS single FROM round), last AS (SELECT "generatorPublicKey" AS pk, timestamp FROM round ORDER BY height DESC LIMIT 1) INSERT INTO rounds_fees SELECT round.height, last.timestamp, (fees.single + (CASE WHEN last.pk = round."generatorPublicKey" AND last.timestamp = round.timestamp THEN (fees.total - fees.single * 101) ELSE 0 END)) AS fees, round."generatorPublicKey" AS "publicKey" FROM last, fees, round ORDER BY round.height ASC; RETURN NULL; END $$;


ALTER FUNCTION public.round_fees_insert() OWNER TO rise;

--
-- Name: rounds_fees_init(); Type: FUNCTION; Schema: public; Owner: rise
--

CREATE FUNCTION public.rounds_fees_init() RETURNS void
    LANGUAGE plpgsql
    AS $$ DECLARE row record; BEGIN RAISE NOTICE 'Calculating fees for rounds, please wait...'; FOR row IN SELECT CEIL(height / 101::float)::int AS round FROM blocks WHERE height % 101 = 0 AND height NOT IN (SELECT height FROM rounds_fees) GROUP BY CEIL(height / 101::float)::int ORDER BY CEIL(height / 101::float)::int ASC LOOP WITH round AS (SELECT timestamp, height, "generatorPublicKey", "totalFee" FROM blocks WHERE CEIL(height / 101::float)::int = row.round), fees AS (SELECT SUM("totalFee") AS total, FLOOR(SUM("totalFee") / 101) AS single FROM round), last AS (SELECT "generatorPublicKey" AS pk, timestamp FROM round ORDER BY height DESC LIMIT 1) INSERT INTO rounds_fees SELECT round.height, last.timestamp, (fees.single + (CASE WHEN last.pk = round."generatorPublicKey" AND last.timestamp = round.timestamp THEN (fees.total - fees.single * 101) ELSE 0 END)) AS fees, round."generatorPublicKey" AS "publicKey" FROM last, fees, round ORDER BY round.height ASC; END LOOP; RETURN; END $$;


ALTER FUNCTION public.rounds_fees_init() OWNER TO rise;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: blocks; Type: TABLE; Schema: public; Owner: rise
--

CREATE TABLE public.blocks (
    id character varying(20) NOT NULL,
    "rowId" integer NOT NULL,
    version integer NOT NULL,
    "timestamp" integer NOT NULL,
    height integer NOT NULL,
    "previousBlock" character varying(20),
    "numberOfTransactions" integer NOT NULL,
    "totalAmount" bigint NOT NULL,
    "totalFee" bigint NOT NULL,
    reward bigint NOT NULL,
    "payloadLength" integer NOT NULL,
    "payloadHash" bytea NOT NULL,
    "generatorPublicKey" bytea NOT NULL,
    "blockSignature" bytea NOT NULL
);


ALTER TABLE public.blocks OWNER TO rise;

--
-- Name: blocks_list; Type: VIEW; Schema: public; Owner: rise
--

CREATE VIEW public.blocks_list AS
 SELECT b.id AS b_id,
    b.version AS b_version,
    b."timestamp" AS b_timestamp,
    b.height AS b_height,
    b."previousBlock" AS "b_previousBlock",
    b."numberOfTransactions" AS "b_numberOfTransactions",
    b."totalAmount" AS "b_totalAmount",
    b."totalFee" AS "b_totalFee",
    b.reward AS b_reward,
    b."payloadLength" AS "b_payloadLength",
    encode(b."payloadHash", 'hex'::text) AS "b_payloadHash",
    encode(b."generatorPublicKey", 'hex'::text) AS "b_generatorPublicKey",
    encode(b."blockSignature", 'hex'::text) AS "b_blockSignature",
    (( SELECT (max(blocks.height) + 1)
           FROM public.blocks) - b.height) AS b_confirmations
   FROM public.blocks b;


ALTER TABLE public.blocks_list OWNER TO rise;

--
-- Name: blocks_rowId_seq; Type: SEQUENCE; Schema: public; Owner: rise
--

CREATE SEQUENCE public."blocks_rowId_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public."blocks_rowId_seq" OWNER TO rise;

--
-- Name: blocks_rowId_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: rise
--

ALTER SEQUENCE public."blocks_rowId_seq" OWNED BY public.blocks."rowId";


--
-- Name: delegates; Type: TABLE; Schema: public; Owner: rise
--

CREATE TABLE public.delegates (
    username character varying(20) NOT NULL,
    "transactionId" character varying(20) NOT NULL
);


ALTER TABLE public.delegates OWNER TO rise;

--
-- Name: exceptions; Type: TABLE; Schema: public; Owner: rise
--

CREATE TABLE public.exceptions (
    type character varying(10) NOT NULL,
    key character varying(255) NOT NULL,
    "remainingCount" integer NOT NULL
);


ALTER TABLE public.exceptions OWNER TO rise;

--
-- Name: forks_stat; Type: TABLE; Schema: public; Owner: rise
--

CREATE TABLE public.forks_stat (
    "delegatePublicKey" bytea NOT NULL,
    "blockTimestamp" integer NOT NULL,
    "blockId" character varying(20) NOT NULL,
    "blockHeight" integer NOT NULL,
    "previousBlock" character varying(20) NOT NULL,
    cause integer NOT NULL
);


ALTER TABLE public.forks_stat OWNER TO rise;

--
-- Name: multisignatures; Type: TABLE; Schema: public; Owner: rise
--

CREATE TABLE public.multisignatures (
    min integer NOT NULL,
    lifetime integer NOT NULL,
    keysgroup text NOT NULL,
    "transactionId" character varying(20) NOT NULL
);


ALTER TABLE public.multisignatures OWNER TO rise;

--
-- Name: signatures; Type: TABLE; Schema: public; Owner: rise
--

CREATE TABLE public.signatures (
    "transactionId" character varying(20) NOT NULL,
    "publicKey" bytea NOT NULL
);


ALTER TABLE public.signatures OWNER TO rise;

--
-- Name: trs; Type: TABLE; Schema: public; Owner: rise
--

CREATE TABLE public.trs (
    id character varying(20) NOT NULL,
    "rowId" integer NOT NULL,
    "blockId" character varying(20) NOT NULL,
    type smallint NOT NULL,
    "timestamp" integer NOT NULL,
    "senderPublicKey" bytea NOT NULL,
    "senderId" character varying(22) NOT NULL,
    "recipientId" character varying(22),
    amount bigint NOT NULL,
    fee bigint NOT NULL,
    signature bytea NOT NULL,
    "signSignature" bytea,
    "requesterPublicKey" bytea,
    signatures text,
    height integer NOT NULL,
    CONSTRAINT cnst_amount CHECK ((amount >= 0)),
    CONSTRAINT cnst_fee CHECK ((fee >= 0)),
    CONSTRAINT upperaddresses CHECK (((upper(("recipientId")::text) = ("recipientId")::text) AND (upper(("senderId")::text) = ("senderId")::text)))
);


ALTER TABLE public.trs OWNER TO rise;

--
-- Name: votes; Type: TABLE; Schema: public; Owner: rise
--

CREATE TABLE public.votes (
    votes text,
    "transactionId" character varying(20) NOT NULL
);


ALTER TABLE public.votes OWNER TO rise;

--
-- Name: full_blocks_list; Type: VIEW; Schema: public; Owner: rise
--

CREATE VIEW public.full_blocks_list AS
 SELECT b.id AS b_id,
    b.version AS b_version,
    b."timestamp" AS b_timestamp,
    b.height AS b_height,
    b."previousBlock" AS "b_previousBlock",
    b."numberOfTransactions" AS "b_numberOfTransactions",
    b."totalAmount" AS "b_totalAmount",
    b."totalFee" AS "b_totalFee",
    b.reward AS b_reward,
    b."payloadLength" AS "b_payloadLength",
    encode(b."payloadHash", 'hex'::text) AS "b_payloadHash",
    encode(b."generatorPublicKey", 'hex'::text) AS "b_generatorPublicKey",
    encode(b."blockSignature", 'hex'::text) AS "b_blockSignature",
    t.id AS t_id,
    t."rowId" AS "t_rowId",
    t.type AS t_type,
    t."timestamp" AS t_timestamp,
    encode(t."senderPublicKey", 'hex'::text) AS "t_senderPublicKey",
    t."senderId" AS "t_senderId",
    t."recipientId" AS "t_recipientId",
    t.amount AS t_amount,
    t.fee AS t_fee,
    encode(t.signature, 'hex'::text) AS t_signature,
    encode(t."signSignature", 'hex'::text) AS "t_signSignature",
    encode(s."publicKey", 'hex'::text) AS "s_publicKey",
    d.username AS d_username,
    v.votes AS v_votes,
    m.min AS m_min,
    m.lifetime AS m_lifetime,
    m.keysgroup AS m_keysgroup,
    encode(t."requesterPublicKey", 'hex'::text) AS "t_requesterPublicKey",
    t.signatures AS t_signatures
   FROM (((((public.blocks b
     LEFT JOIN public.trs t ON (((t."blockId")::text = (b.id)::text)))
     LEFT JOIN public.delegates d ON (((d."transactionId")::text = (t.id)::text)))
     LEFT JOIN public.votes v ON (((v."transactionId")::text = (t.id)::text)))
     LEFT JOIN public.signatures s ON (((s."transactionId")::text = (t.id)::text)))
     LEFT JOIN public.multisignatures m ON (((m."transactionId")::text = (t.id)::text)));


ALTER TABLE public.full_blocks_list OWNER TO rise;

--
-- Name: info; Type: TABLE; Schema: public; Owner: rise
--

CREATE TABLE public.info (
    key character varying(20) NOT NULL,
    value character varying(255) NOT NULL
);


ALTER TABLE public.info OWNER TO rise;

--
-- Name: mem_accounts; Type: TABLE; Schema: public; Owner: rise
--

CREATE TABLE public.mem_accounts (
    username character varying(20),
    "isDelegate" smallint DEFAULT 0,
    "u_isDelegate" smallint DEFAULT 0,
    "secondSignature" smallint DEFAULT 0,
    "u_secondSignature" smallint DEFAULT 0,
    u_username character varying(20),
    address character varying(22) NOT NULL,
    "publicKey" bytea,
    "secondPublicKey" bytea,
    balance bigint DEFAULT 0,
    u_balance bigint DEFAULT 0,
    vote bigint DEFAULT 0,
    rate bigint DEFAULT 0,
    delegates text,
    u_delegates text,
    multisignatures text,
    u_multisignatures text,
    multimin bigint DEFAULT 0,
    u_multimin bigint DEFAULT 0,
    multilifetime bigint DEFAULT 0,
    u_multilifetime bigint DEFAULT 0,
    "blockId" character varying(20),
    nameexist smallint DEFAULT 0,
    u_nameexist smallint DEFAULT 0,
    producedblocks integer DEFAULT 0,
    missedblocks integer DEFAULT 0,
    fees bigint DEFAULT 0,
    rewards bigint DEFAULT 0,
    virgin smallint DEFAULT 1,
    "votesWeight" bigint DEFAULT 0
);


ALTER TABLE public.mem_accounts OWNER TO rise;

--
-- Name: mem_accounts2delegates; Type: TABLE; Schema: public; Owner: rise
--

CREATE TABLE public.mem_accounts2delegates (
    "accountId" character varying(22) NOT NULL,
    "dependentId" character varying(64) NOT NULL
);


ALTER TABLE public.mem_accounts2delegates OWNER TO rise;

--
-- Name: mem_accounts2multisignatures; Type: TABLE; Schema: public; Owner: rise
--

CREATE TABLE public.mem_accounts2multisignatures (
    "accountId" character varying(22) NOT NULL,
    "dependentId" character varying(64) NOT NULL
);


ALTER TABLE public.mem_accounts2multisignatures OWNER TO rise;

--
-- Name: mem_accounts2u_delegates; Type: TABLE; Schema: public; Owner: rise
--

CREATE TABLE public.mem_accounts2u_delegates (
    "accountId" character varying(22) NOT NULL,
    "dependentId" character varying(64) NOT NULL
);


ALTER TABLE public.mem_accounts2u_delegates OWNER TO rise;

--
-- Name: mem_accounts2u_multisignatures; Type: TABLE; Schema: public; Owner: rise
--

CREATE TABLE public.mem_accounts2u_multisignatures (
    "accountId" character varying(22) NOT NULL,
    "dependentId" character varying(64) NOT NULL
);


ALTER TABLE public.mem_accounts2u_multisignatures OWNER TO rise;

--
-- Name: mem_round; Type: TABLE; Schema: public; Owner: rise
--

CREATE TABLE public.mem_round (
    address character varying(22),
    amount bigint,
    delegate character varying(64),
    "blockId" character varying(20),
    round bigint
);


ALTER TABLE public.mem_round OWNER TO rise;

--
-- Name: mem_round_snapshot; Type: TABLE; Schema: public; Owner: rise
--

CREATE TABLE public.mem_round_snapshot (
    address character varying(22),
    amount bigint,
    delegate character varying(64),
    "blockId" character varying(20),
    round bigint
);


ALTER TABLE public.mem_round_snapshot OWNER TO rise;

--
-- Name: mem_votes_snapshot; Type: TABLE; Schema: public; Owner: rise
--

CREATE TABLE public.mem_votes_snapshot (
    address character varying(22),
    vote bigint
);


ALTER TABLE public.mem_votes_snapshot OWNER TO rise;

--
-- Name: migrations; Type: TABLE; Schema: public; Owner: rise
--

CREATE TABLE public.migrations (
    id character varying(22) NOT NULL,
    name text NOT NULL
);


ALTER TABLE public.migrations OWNER TO rise;

--
-- Name: peers; Type: TABLE; Schema: public; Owner: rise
--

CREATE TABLE public.peers (
    id integer NOT NULL,
    ip inet NOT NULL,
    port smallint NOT NULL,
    state smallint NOT NULL,
    os character varying(64),
    version character varying(11),
    clock bigint,
    broadhash bytea,
    height integer
);


ALTER TABLE public.peers OWNER TO rise;

--
-- Name: peers_id_seq; Type: SEQUENCE; Schema: public; Owner: rise
--

CREATE SEQUENCE public.peers_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.peers_id_seq OWNER TO rise;

--
-- Name: peers_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: rise
--

ALTER SEQUENCE public.peers_id_seq OWNED BY public.peers.id;


--
-- Name: rounds_fees; Type: TABLE; Schema: public; Owner: rise
--

CREATE TABLE public.rounds_fees (
    height integer NOT NULL,
    "timestamp" integer NOT NULL,
    fees bigint NOT NULL,
    "publicKey" bytea NOT NULL
);


ALTER TABLE public.rounds_fees OWNER TO rise;

--
-- Name: trs_rowId_seq; Type: SEQUENCE; Schema: public; Owner: rise
--

CREATE SEQUENCE public."trs_rowId_seq"
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public."trs_rowId_seq" OWNER TO rise;

--
-- Name: trs_rowId_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: rise
--

ALTER SEQUENCE public."trs_rowId_seq" OWNED BY public.trs."rowId";


--
-- Name: blocks rowId; Type: DEFAULT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.blocks ALTER COLUMN "rowId" SET DEFAULT nextval('public."blocks_rowId_seq"'::regclass);


--
-- Name: peers id; Type: DEFAULT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.peers ALTER COLUMN id SET DEFAULT nextval('public.peers_id_seq'::regclass);


--
-- Name: trs rowId; Type: DEFAULT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.trs ALTER COLUMN "rowId" SET DEFAULT nextval('public."trs_rowId_seq"'::regclass);


--
-- Data for Name: blocks; Type: TABLE DATA; Schema: public; Owner: rise
--

COPY public.blocks (id, "rowId", version, "timestamp", height, "previousBlock", "numberOfTransactions", "totalAmount", "totalFee", reward, "payloadLength", "payloadHash", "generatorPublicKey", "blockSignature") FROM stdin;
\.
COPY public.blocks (id, "rowId", version, "timestamp", height, "previousBlock", "numberOfTransactions", "totalAmount", "totalFee", reward, "payloadLength", "payloadHash", "generatorPublicKey", "blockSignature") FROM '$$PATH$$/2336.dat';

--
-- Name: blocks_rowId_seq; Type: SEQUENCE SET; Schema: public; Owner: rise
--

SELECT pg_catalog.setval('public."blocks_rowId_seq"', 1003665, true);


--
-- Data for Name: delegates; Type: TABLE DATA; Schema: public; Owner: rise
--

COPY public.delegates (username, "transactionId") FROM stdin;
\.
COPY public.delegates (username, "transactionId") FROM '$$PATH$$/2338.dat';

--
-- Data for Name: exceptions; Type: TABLE DATA; Schema: public; Owner: rise
--

COPY public.exceptions (type, key, "remainingCount") FROM stdin;
\.
COPY public.exceptions (type, key, "remainingCount") FROM '$$PATH$$/2350.dat';

--
-- Data for Name: forks_stat; Type: TABLE DATA; Schema: public; Owner: rise
--

COPY public.forks_stat ("delegatePublicKey", "blockTimestamp", "blockId", "blockHeight", "previousBlock", cause) FROM stdin;
\.
COPY public.forks_stat ("delegatePublicKey", "blockTimestamp", "blockId", "blockHeight", "previousBlock", cause) FROM '$$PATH$$/2339.dat';

--
-- Data for Name: info; Type: TABLE DATA; Schema: public; Owner: rise
--

COPY public.info (key, value) FROM stdin;
\.
COPY public.info (key, value) FROM '$$PATH$$/2349.dat';

--
-- Data for Name: mem_accounts; Type: TABLE DATA; Schema: public; Owner: rise
--

COPY public.mem_accounts (username, "isDelegate", "u_isDelegate", "secondSignature", "u_secondSignature", u_username, address, "publicKey", "secondPublicKey", balance, u_balance, vote, rate, delegates, u_delegates, multisignatures, u_multisignatures, multimin, u_multimin, multilifetime, u_multilifetime, "blockId", nameexist, u_nameexist, producedblocks, missedblocks, fees, rewards, virgin, "votesWeight") FROM stdin;
\.
COPY public.mem_accounts (username, "isDelegate", "u_isDelegate", "secondSignature", "u_secondSignature", u_username, address, "publicKey", "secondPublicKey", balance, u_balance, vote, rate, delegates, u_delegates, multisignatures, u_multisignatures, multimin, u_multimin, multilifetime, u_multilifetime, "blockId", nameexist, u_nameexist, producedblocks, missedblocks, fees, rewards, virgin, "votesWeight") FROM '$$PATH$$/2351.dat';

--
-- Data for Name: mem_accounts2delegates; Type: TABLE DATA; Schema: public; Owner: rise
--

COPY public.mem_accounts2delegates ("accountId", "dependentId") FROM stdin;
\.
COPY public.mem_accounts2delegates ("accountId", "dependentId") FROM '$$PATH$$/2353.dat';

--
-- Data for Name: mem_accounts2multisignatures; Type: TABLE DATA; Schema: public; Owner: rise
--

COPY public.mem_accounts2multisignatures ("accountId", "dependentId") FROM stdin;
\.
COPY public.mem_accounts2multisignatures ("accountId", "dependentId") FROM '$$PATH$$/2355.dat';

--
-- Data for Name: mem_accounts2u_delegates; Type: TABLE DATA; Schema: public; Owner: rise
--

COPY public.mem_accounts2u_delegates ("accountId", "dependentId") FROM stdin;
\.
COPY public.mem_accounts2u_delegates ("accountId", "dependentId") FROM '$$PATH$$/2354.dat';

--
-- Data for Name: mem_accounts2u_multisignatures; Type: TABLE DATA; Schema: public; Owner: rise
--

COPY public.mem_accounts2u_multisignatures ("accountId", "dependentId") FROM stdin;
\.
COPY public.mem_accounts2u_multisignatures ("accountId", "dependentId") FROM '$$PATH$$/2356.dat';

--
-- Data for Name: mem_round; Type: TABLE DATA; Schema: public; Owner: rise
--

COPY public.mem_round (address, amount, delegate, "blockId", round) FROM stdin;
\.
COPY public.mem_round (address, amount, delegate, "blockId", round) FROM '$$PATH$$/2352.dat';

--
-- Data for Name: mem_round_snapshot; Type: TABLE DATA; Schema: public; Owner: rise
--

COPY public.mem_round_snapshot (address, amount, delegate, "blockId", round) FROM stdin;
\.
COPY public.mem_round_snapshot (address, amount, delegate, "blockId", round) FROM '$$PATH$$/2357.dat';

--
-- Data for Name: mem_votes_snapshot; Type: TABLE DATA; Schema: public; Owner: rise
--

COPY public.mem_votes_snapshot (address, vote) FROM stdin;
\.
COPY public.mem_votes_snapshot (address, vote) FROM '$$PATH$$/2358.dat';

--
-- Data for Name: migrations; Type: TABLE DATA; Schema: public; Owner: rise
--

COPY public.migrations (id, name) FROM stdin;
\.
COPY public.migrations (id, name) FROM '$$PATH$$/2344.dat';

--
-- Data for Name: multisignatures; Type: TABLE DATA; Schema: public; Owner: rise
--

COPY public.multisignatures (min, lifetime, keysgroup, "transactionId") FROM stdin;
\.
COPY public.multisignatures (min, lifetime, keysgroup, "transactionId") FROM '$$PATH$$/2340.dat';

--
-- Data for Name: peers; Type: TABLE DATA; Schema: public; Owner: rise
--

COPY public.peers (id, ip, port, state, os, version, clock, broadhash, height) FROM stdin;
\.
COPY public.peers (id, ip, port, state, os, version, clock, broadhash, height) FROM '$$PATH$$/2345.dat';

--
-- Name: peers_id_seq; Type: SEQUENCE SET; Schema: public; Owner: rise
--

SELECT pg_catalog.setval('public.peers_id_seq', 5748, true);


--
-- Data for Name: rounds_fees; Type: TABLE DATA; Schema: public; Owner: rise
--

COPY public.rounds_fees (height, "timestamp", fees, "publicKey") FROM stdin;
\.
COPY public.rounds_fees (height, "timestamp", fees, "publicKey") FROM '$$PATH$$/2347.dat';

--
-- Data for Name: signatures; Type: TABLE DATA; Schema: public; Owner: rise
--

COPY public.signatures ("transactionId", "publicKey") FROM stdin;
\.
COPY public.signatures ("transactionId", "publicKey") FROM '$$PATH$$/2341.dat';

--
-- Data for Name: trs; Type: TABLE DATA; Schema: public; Owner: rise
--

COPY public.trs (id, "rowId", "blockId", type, "timestamp", "senderPublicKey", "senderId", "recipientId", amount, fee, signature, "signSignature", "requesterPublicKey", signatures, height) FROM stdin;
\.
COPY public.trs (id, "rowId", "blockId", type, "timestamp", "senderPublicKey", "senderId", "recipientId", amount, fee, signature, "signSignature", "requesterPublicKey", signatures, height) FROM '$$PATH$$/2342.dat';

--
-- Name: trs_rowId_seq; Type: SEQUENCE SET; Schema: public; Owner: rise
--

SELECT pg_catalog.setval('public."trs_rowId_seq"', 390298, true);


--
-- Data for Name: votes; Type: TABLE DATA; Schema: public; Owner: rise
--

COPY public.votes (votes, "transactionId") FROM stdin;
\.
COPY public.votes (votes, "transactionId") FROM '$$PATH$$/2343.dat';

--
-- Name: peers address_unique; Type: CONSTRAINT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.peers
    ADD CONSTRAINT address_unique UNIQUE (ip, port);


--
-- Name: blocks blocks_pkey; Type: CONSTRAINT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.blocks
    ADD CONSTRAINT blocks_pkey PRIMARY KEY (id);


--
-- Name: delegates delegates_unique; Type: CONSTRAINT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.delegates
    ADD CONSTRAINT delegates_unique UNIQUE (username, "transactionId");


--
-- Name: exceptions exceptions_pkey; Type: CONSTRAINT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.exceptions
    ADD CONSTRAINT exceptions_pkey PRIMARY KEY (type, key);


--
-- Name: info info_pkey; Type: CONSTRAINT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.info
    ADD CONSTRAINT info_pkey PRIMARY KEY (key);


--
-- Name: mem_accounts mem_accounts_pkey; Type: CONSTRAINT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.mem_accounts
    ADD CONSTRAINT mem_accounts_pkey PRIMARY KEY (address);


--
-- Name: migrations migrations_pkey; Type: CONSTRAINT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.migrations
    ADD CONSTRAINT migrations_pkey PRIMARY KEY (id);


--
-- Name: peers peers_pkey; Type: CONSTRAINT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.peers
    ADD CONSTRAINT peers_pkey PRIMARY KEY (id);


--
-- Name: signatures signatures_pkey; Type: CONSTRAINT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.signatures
    ADD CONSTRAINT signatures_pkey PRIMARY KEY ("transactionId");


--
-- Name: trs trs_pkey; Type: CONSTRAINT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.trs
    ADD CONSTRAINT trs_pkey PRIMARY KEY (id);


--
-- Name: blocks_generator_public_key; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX blocks_generator_public_key ON public.blocks USING btree ("generatorPublicKey");


--
-- Name: blocks_height; Type: INDEX; Schema: public; Owner: rise
--

CREATE UNIQUE INDEX blocks_height ON public.blocks USING btree (height);


--
-- Name: blocks_numberOfTransactions; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX "blocks_numberOfTransactions" ON public.blocks USING btree ("numberOfTransactions");


--
-- Name: blocks_previousBlock; Type: INDEX; Schema: public; Owner: rise
--

CREATE UNIQUE INDEX "blocks_previousBlock" ON public.blocks USING btree ("previousBlock");


--
-- Name: blocks_reward; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX blocks_reward ON public.blocks USING btree (reward);


--
-- Name: blocks_rounds; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX blocks_rounds ON public.blocks USING btree (((ceil(((height)::double precision / (101)::double precision)))::integer));


--
-- Name: blocks_rowId; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX "blocks_rowId" ON public.blocks USING btree ("rowId");


--
-- Name: blocks_timestamp; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX blocks_timestamp ON public.blocks USING btree ("timestamp");


--
-- Name: blocks_totalAmount; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX "blocks_totalAmount" ON public.blocks USING btree ("totalAmount");


--
-- Name: blocks_totalFee; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX "blocks_totalFee" ON public.blocks USING btree ("totalFee");


--
-- Name: delegates_trs_id; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX delegates_trs_id ON public.delegates USING btree ("transactionId");


--
-- Name: idx_accounts_address; Type: INDEX; Schema: public; Owner: rise
--

CREATE UNIQUE INDEX idx_accounts_address ON public.mem_accounts USING btree (address);


--
-- Name: idx_trs_id; Type: INDEX; Schema: public; Owner: rise
--

CREATE UNIQUE INDEX idx_trs_id ON public.trs USING btree (id);


--
-- Name: mem_accounts2delegates_accountId; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX "mem_accounts2delegates_accountId" ON public.mem_accounts2delegates USING btree ("accountId");


--
-- Name: mem_accounts2multisignatures_accountId; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX "mem_accounts2multisignatures_accountId" ON public.mem_accounts2multisignatures USING btree ("accountId");


--
-- Name: mem_accounts2u_delegates_accountId; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX "mem_accounts2u_delegates_accountId" ON public.mem_accounts2u_delegates USING btree ("accountId");


--
-- Name: mem_accounts2u_multisignatures_accountId; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX "mem_accounts2u_multisignatures_accountId" ON public.mem_accounts2u_multisignatures USING btree ("accountId");


--
-- Name: mem_accounts_balance; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX mem_accounts_balance ON public.mem_accounts USING btree (balance);


--
-- Name: mem_round_address; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX mem_round_address ON public.mem_round USING btree (address);


--
-- Name: mem_round_round; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX mem_round_round ON public.mem_round USING btree (round);


--
-- Name: multisignatures_trs_id; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX multisignatures_trs_id ON public.multisignatures USING btree ("transactionId");


--
-- Name: peers_broadhash; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX peers_broadhash ON public.peers USING btree (broadhash);


--
-- Name: peers_height; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX peers_height ON public.peers USING btree (height);


--
-- Name: rounds_fees_fees; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX rounds_fees_fees ON public.rounds_fees USING btree (fees);


--
-- Name: rounds_fees_height; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX rounds_fees_height ON public.rounds_fees USING btree (height);


--
-- Name: rounds_fees_public_key; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX rounds_fees_public_key ON public.rounds_fees USING btree ("publicKey");


--
-- Name: rounds_fees_round; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX rounds_fees_round ON public.rounds_fees USING btree (((ceil(((height)::double precision / (101)::double precision)))::integer));


--
-- Name: rounds_fees_timestamp; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX rounds_fees_timestamp ON public.rounds_fees USING btree ("timestamp");


--
-- Name: signatures_trs_id; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX signatures_trs_id ON public.signatures USING btree ("transactionId");


--
-- Name: trs_block_id; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX trs_block_id ON public.trs USING btree ("blockId");


--
-- Name: trs_recipient_id; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX trs_recipient_id ON public.trs USING btree ("recipientId");


--
-- Name: trs_rowId; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX "trs_rowId" ON public.trs USING btree ("rowId");


--
-- Name: trs_senderPublicKey; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX "trs_senderPublicKey" ON public.trs USING btree ("senderPublicKey");


--
-- Name: trs_sender_id; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX trs_sender_id ON public.trs USING btree ("senderId");


--
-- Name: trs_timestamp; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX trs_timestamp ON public.trs USING btree ("timestamp");


--
-- Name: trs_type; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX trs_type ON public.trs USING btree (type);


--
-- Name: trs_upper_recipient_id; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX trs_upper_recipient_id ON public.trs USING btree (upper(("recipientId")::text));


--
-- Name: trs_upper_sender_id; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX trs_upper_sender_id ON public.trs USING btree (upper(("senderId")::text));


--
-- Name: votes_trs_id; Type: INDEX; Schema: public; Owner: rise
--

CREATE INDEX votes_trs_id ON public.votes USING btree ("transactionId");


--
-- Name: blocks rounds_fees_delete; Type: TRIGGER; Schema: public; Owner: rise
--

CREATE TRIGGER rounds_fees_delete AFTER DELETE ON public.blocks FOR EACH ROW WHEN (((old.height % 101) = 0)) EXECUTE PROCEDURE public.round_fees_delete();


--
-- Name: blocks rounds_fees_insert; Type: TRIGGER; Schema: public; Owner: rise
--

CREATE TRIGGER rounds_fees_insert AFTER INSERT ON public.blocks FOR EACH ROW WHEN (((new.height % 101) = 0)) EXECUTE PROCEDURE public.round_fees_insert();


--
-- Name: mem_accounts trg_memaccounts_update; Type: TRIGGER; Schema: public; Owner: rise
--

CREATE TRIGGER trg_memaccounts_update BEFORE UPDATE OF balance, u_balance ON public.mem_accounts FOR EACH ROW EXECUTE PROCEDURE public.proc_balance_check();


--
-- Name: blocks blocks_previousBlock_fkey; Type: FK CONSTRAINT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.blocks
    ADD CONSTRAINT "blocks_previousBlock_fkey" FOREIGN KEY ("previousBlock") REFERENCES public.blocks(id) ON DELETE SET NULL;


--
-- Name: delegates delegates_transactionId_fkey; Type: FK CONSTRAINT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.delegates
    ADD CONSTRAINT "delegates_transactionId_fkey" FOREIGN KEY ("transactionId") REFERENCES public.trs(id) ON DELETE CASCADE;


--
-- Name: mem_accounts2delegates mem_accounts2delegates_accountId_fkey; Type: FK CONSTRAINT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.mem_accounts2delegates
    ADD CONSTRAINT "mem_accounts2delegates_accountId_fkey" FOREIGN KEY ("accountId") REFERENCES public.mem_accounts(address) ON DELETE CASCADE;


--
-- Name: mem_accounts2multisignatures mem_accounts2multisignatures_accountId_fkey; Type: FK CONSTRAINT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.mem_accounts2multisignatures
    ADD CONSTRAINT "mem_accounts2multisignatures_accountId_fkey" FOREIGN KEY ("accountId") REFERENCES public.mem_accounts(address) ON DELETE CASCADE;


--
-- Name: mem_accounts2u_delegates mem_accounts2u_delegates_accountId_fkey; Type: FK CONSTRAINT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.mem_accounts2u_delegates
    ADD CONSTRAINT "mem_accounts2u_delegates_accountId_fkey" FOREIGN KEY ("accountId") REFERENCES public.mem_accounts(address) ON DELETE CASCADE;


--
-- Name: mem_accounts2u_multisignatures mem_accounts2u_multisignatures_accountId_fkey; Type: FK CONSTRAINT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.mem_accounts2u_multisignatures
    ADD CONSTRAINT "mem_accounts2u_multisignatures_accountId_fkey" FOREIGN KEY ("accountId") REFERENCES public.mem_accounts(address) ON DELETE CASCADE;


--
-- Name: multisignatures multisignatures_transactionId_fkey; Type: FK CONSTRAINT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.multisignatures
    ADD CONSTRAINT "multisignatures_transactionId_fkey" FOREIGN KEY ("transactionId") REFERENCES public.trs(id) ON DELETE CASCADE;


--
-- Name: signatures signatures_transactionId_fkey; Type: FK CONSTRAINT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.signatures
    ADD CONSTRAINT "signatures_transactionId_fkey" FOREIGN KEY ("transactionId") REFERENCES public.trs(id) ON DELETE CASCADE;


--
-- Name: trs trs_blockId_fkey; Type: FK CONSTRAINT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.trs
    ADD CONSTRAINT "trs_blockId_fkey" FOREIGN KEY ("blockId") REFERENCES public.blocks(id) ON DELETE CASCADE;


--
-- Name: votes votes_transactionId_fkey; Type: FK CONSTRAINT; Schema: public; Owner: rise
--

ALTER TABLE ONLY public.votes
    ADD CONSTRAINT "votes_transactionId_fkey" FOREIGN KEY ("transactionId") REFERENCES public.trs(id) ON DELETE CASCADE;


--
-- PostgreSQL database dump complete
--

